# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2011 Smartmode LTD (<http://www.smartmode.co.uk>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

{
    'name' : 'Bank Statements modifications',
    'version' : '1',
    'depends' : [
                'base',
                'account',
                ],
    'author' : 'SmartMode LTD',
    'description': '''This module updates the default bank statement from Accounting > Periodical processing > Statements > Statements Reconciliation to allow the additional new functionality:

    * Adds the currency values alongside the base currency to the transactions.
    * Introduces correct calculations of foreign currency banks as follows: Opening balance + new entries denominated in foreign currency = Closing balance.
    * Adds a print statement template.
    * Allows for the statements to be un-reconciled if there are no newer statements.''',
    'website' : 'http://www.smartmode.co.uk/',
    'category' : 'Accounting',
    'init_xml' : [],
    'demo_xml' : [],
    'update_xml' :  [
                    'sm_bank_statement_report.xml',
                    'sm_bank_statement_view.xml',
                    'sm_bank_statement_menu.xml',
                    ],
    'active': False,
    'installable': True,

}
