# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2011 Smartmode LTD (<http://www.smartmode.co.uk>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time

from osv import fields, osv
from tools.translate import _
import decimal_precision as dp
import pooler

class account_bank_statement(osv.osv):
    _name = "account.bank.statement"
    _inherit = "account.bank.statement"


    def button_cancel(self, cr, uid, ids, context=None):
        current_statement_date = self.browse(cr, uid, ids, context=context)[0].date
        older_statemet_ids = self.search(cr, uid, [('date', '>', current_statement_date)], context=context)
        if older_statemet_ids:
            raise osv.except_osv('Alert!', 'You cannot un-reconcile this statement. Cancel any newer statements first!')
        done = []
        account_move_obj = self.pool.get('account.move')
        for st in self.browse(cr, uid, ids, context=context):
            if st.state=='draft':
                continue
            ids = []
            for line in st.line_ids:
                ids += [x.id for x in line.move_ids]
            account_move_obj.unlink(cr, uid, ids, context)
            done.append(st.id)
        return self.write(cr, uid, done, {'state':'draft'}, context=context)

#Exchange remake
    def _end_balance(self, cr, uid, ids, name, attr, context={}):
        res_users_obj = pooler.get_pool(cr.dbname).get('res.users')
        res = {}

        company_currency_id = res_users_obj.browse(cr, uid, uid,
                context=context).company_id.currency_id.id

        statements = self.browse(cr, uid, ids, context=context)
        for statement in statements:
            res[statement.id] = statement.balance_start
            total_debit = 0
            total_credit = 0
            total_amount_currency = 0
            for line in statement.move_line_ids:
                total_debit += line.debit
                total_credit += line.credit
                total_amount_currency += line.amount_currency
            if statement.journal_id.currency and statement.journal_id.currency.id <> statement.company_id.currency_id.id:
                res[statement.id] += total_amount_currency 
            else:
                res[statement.id] += total_debit - total_credit
        for r in res:
            res[r] = round(res[r], 2)
        return res

    _columns = {
        'balance_end': fields.function(_end_balance, string='Balance', method=True, store=True),
    }


account_bank_statement()
