from osv import osv, fields
from tools.misc import logging
import time
import datetime

class sm_bank_statement_report_wizard(osv.osv_memory):
    _name = 'sm_bank_statement.report_wizard'
    _description = 'Print Journal Items'
    _columns = {
        'bank_statement': fields.many2one('account.bank.statement', 'Bank Statement'),
    }

    def _reget_form (self, cr, uid, ids, context={}):
        self.form = self.browse(cr, uid, ids, context=context)[0]
        return True

    def default_get(self, cr, uid, fields, context={}):
        result = super(osv.osv_memory, self).default_get(cr, uid, fields,  context=context)
        result.update({'bank_statement': None or context['active_ids'][0],
                      })
        return result

    def print_move_lines(self, cr, uid, ids, context={}):
        self._reget_form(cr, uid, ids, context=context)
        bank_statement = self.pool.get('account.bank.statement').browse(cr, uid, self.form.bank_statement.id, context=context)
        active_ids = context['active_ids']
        datas = {'ids': active_ids}
        datas['name'] = bank_statement.name
        datas['date'] = bank_statement.date
        datas['journal'] = bank_statement.journal_id.name
        datas['period'] = bank_statement.period_id.name
        datas['balance_start'] = bank_statement.balance_start
        datas['balance_end'] = bank_statement.balance_end
        move_lines = []
        for move_line in bank_statement.move_line_ids:
            move_lines.append({'name': move_line.name,
                               'date': move_line.date,
                               'ref': move_line.ref,
                               'debit': move_line.debit,
                               'credit': move_line.credit,
                               'amount_currency': move_line.amount_currency,
                               'currency_symbol': move_line.currency_id.symbol,
            })
        move_lines = sorted(move_lines, key=lambda m_list: m_list['date'])
        datas['move_lines'] = move_lines
        datas['total_debit'] = 0
        datas['total_credit'] = 0
        datas['total_amount_currency'] = 0
        for move_line in move_lines:
            datas['total_debit'] += move_line['debit']
            datas['total_credit'] += move_line['credit']
            datas['total_amount_currency'] += move_line['amount_currency']
            datas['currency_symbol'] = move_line['currency_symbol']
        datas['journal_currency_symbol'] = bank_statement.journal_id.currency.symbol
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'sm_bank_statement.report',
            'datas': datas
        }


sm_bank_statement_report_wizard()
